import airflow.utils.yaml as yaml
import rich.console
import rich.table
from airflow.plugins_manager import PluginsDirectorySource as PluginsDirectorySource
from airflow.utils.platform import is_tty as is_tty
from typing import Any, Callable, Sequence

TYPE_CHECKING: bool
def is_data_sequence(data: Sequence[dict | Any]) -> TypeGuard[Sequence[dict]]: ...

class AirflowConsole(rich.console.Console):
    def __init__(self, show_header: bool = ..., *args, **kwargs) -> None: ...
    def print_as_json(self, data: dict): ...
    def print_as_yaml(self, data: dict): ...
    def print_as_table(self, data: list[dict]): ...
    def print_as_plain_table(self, data: list[dict]): ...
    def print_as(self, data: Sequence[dict | Any], output: str, mapper: Callable[[Any], dict] | None = ...) -> None: ...

class SimpleTable(rich.table.Table):
    def __init__(self, *args, **kwargs) -> None: ...
    def add_column(self, *args, **kwargs) -> None: ...
