import typing
from airflow.configuration import conf as conf
from airflow.exceptions import AirflowConfigException as AirflowConfigException
from airflow.metrics.protocols import Timer as Timer
from airflow.metrics.validators import AllowListValidator as AllowListValidator, BlockListValidator as BlockListValidator, validate_stat as validate_stat

TYPE_CHECKING: bool
T: typing.TypeVar
def prepare_stat_with_tags(fn: T) -> T: ...

class SafeStatsdLogger:
    def __init__(self, statsd_client: StatsClient, metrics_validator: ListValidator = ..., influxdb_tags_enabled: bool = ..., metric_tags_validator: ListValidator = ...) -> None: ...
    def incr(self, stat: str = ..., *args, **kwargs) -> None: ...
    def decr(self, stat: str = ..., *args, **kwargs) -> None: ...
    def gauge(self, stat: str = ..., *args, **kwargs) -> None: ...
    def timing(self, stat: str = ..., *args, **kwargs) -> None: ...
    def timer(self, stat: str | None = ..., *args, **kwargs) -> TimerProtocol: ...
def get_statsd_logger(cls) -> SafeStatsdLogger: ...
