import flask.json.provider
import json.decoder
import json.encoder
from airflow.serialization.serde import deserialize as deserialize, serialize as serialize
from airflow.utils.timezone import convert_to_utc as convert_to_utc, is_naive as is_naive
from typing import Any, ClassVar

CLASSNAME: str
DATA: str
SCHEMA_ID: str

class AirflowJsonProvider(flask.json.provider.JSONProvider):
    ensure_ascii: ClassVar[bool] = ...
    sort_keys: ClassVar[bool] = ...
    def dumps(self, obj, **kwargs): ...
    def loads(self, s: str | bytes, **kwargs): ...

class WebEncoder(json.encoder.JSONEncoder):
    def default(self, o: Any) -> Any: ...

class XComEncoder(json.encoder.JSONEncoder):
    def default(self, o: object) -> Any: ...
    def encode(self, o: Any) -> str: ...

class XComDecoder(json.decoder.JSONDecoder):
    def __init__(self, *args, **kwargs) -> None: ...
    def object_hook(self, dct: dict) -> object: ...
    @staticmethod
    def orm_object_hook(dct: dict) -> object: ...

class AirflowJsonEncoder(json.encoder.JSONEncoder):
    def default(self, o: Any) -> Any: ...
